﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Quick_Class_Model_Generator
{
    public class Property
    {
        public String Access;
        public String Name;
        public String Datatype;
        public String Modifier;

        public Property()
        {
            Access = "";
            Name = "";
            Datatype = "";
            Modifier = "";
        }

        public String getVariableDeclarationCode()
        {
            StringBuilder result = new StringBuilder();

            result.Append("    private ");
            if (Instances.Main.chkStaticClass.Enabled) result.Append("static ");
            result.Append(this.Datatype + " ");
            result.AppendLine("m" + this.Name + ";");

            return result.ToString();
        }

        public String getEventOnChangedArgsClassCode()
        {
            StringBuilder result = new StringBuilder();

            result.AppendLine("    public class On" + this.Name + "ChangedArgs : EventArgs");
            result.AppendLine("    {");
            result.AppendLine("        public " + this.Datatype + " OldValue;");
            result.AppendLine("        public " + this.Datatype + " NewValue;");
            result.AppendLine("        ");
            result.AppendLine("        public On" + this.Name + "ChangedArgs(" + this.Datatype + " oldValue, " + this.Datatype + " newValue)");
            result.AppendLine("        {");
            result.AppendLine("            OldValue = oldValue;");
            result.AppendLine("            NewValue = newValue;");
            result.AppendLine("        }");
            result.AppendLine("    }");

            return result.ToString();
        }

        public String getEventDeclarationCode()
        {
            StringBuilder result = new StringBuilder();

            if (this.Modifier == "pr") result.Append("    private ");
            else result.Append("    public ");
            if (Instances.Main.chkStaticClass.Enabled) result.Append("static ");
            result.Append("EventHandler<");
            result.Append("On" + this.Name + "ChangedArgs");
            result.Append("> ");
            result.AppendLine(" On" + this.Name + "Changed;");

            return result.ToString();
        }

        public String getPropertyCode()
        {
            StringBuilder result = new StringBuilder();

            if (this.Modifier == "pr") result.Append("    private ");
            else result.Append("    public ");
            if (Instances.Main.chkStaticClass.Enabled) result.Append("static ");
            result.Append(this.Datatype + " ");
            result.AppendLine(this.Name);

            result.AppendLine("    {");
            if(this.Access == "a")
            {
                result.AppendLine("        get");
                result.AppendLine("        {");
                result.AppendLine("            return m" + this.Name + ";");
                result.AppendLine("        }");

                result.AppendLine("        set");
                result.AppendLine("        {");
                if (Instances.Main.chkGenerateEvents.Checked) result.AppendLine("            if(On" + this.Name + "Changed != null) On" + this.Name + "Changed(this, new On" + this.Name + "ChangedArgs(m" + this.Name + ", value));");
                result.AppendLine("            this.m" + this.Name + " = value;");
                result.AppendLine("        }");
            }
            else
            {
                if (this.Access == "r")
                {
                    result.AppendLine("        get");
                    result.AppendLine("        {");
                    result.AppendLine("            return m" + this.Name + ";");
                    result.AppendLine("        }");
                }
                if (this.Access == "w")
                {
                    result.AppendLine("        set");
                    result.AppendLine("        {");
                    if (Instances.Main.chkGenerateEvents.Checked) result.AppendLine("        if(On" + this.Name + "Changed != null) On" + this.Name + "Changed(this, new On" + this.Name + "ChangedArgs(m" + this.Name + ", value));");
                    result.AppendLine("            this.m" + this.Name + " = value;");
                    result.AppendLine("        }");
                }
            }
            result.AppendLine("    }");

            return result.ToString();
        }

        public static Property parsePropertyFromString(String input)
        {
            Property property = new Property();
            string[] parts = input.Split();

            property.Name = parts[0];
            property.Datatype = parts[1];
            property.Modifier = parts[2];
            if (parts.Length > 3) property.Access = parts[3];
            else property.Access = "a";

            return property;
        }
    }
}
